// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#ifndef _CLICKLINEEDIT_H_
#define _CLICKLINEEDIT_H_

#include <klineedit.h>

class KLDrawClickLineEdit : public KLineEdit
{
	Q_OBJECT;
	Q_PROPERTY(QString clickMessage READ clickMessage WRITE setClickMessage);
	
	public:
		KLDrawClickLineEdit(const QString &msg, QWidget *parent, const char *name = 0L);
		
		void setClickMessage(const QString &msg);
		QString clickMessage() const { return clickMessage_; }
		
		virtual void setText(const QString &text);
		
	protected:
		virtual void drawContents(QPainter *p);
		virtual void dropEvent(QDropEvent *ev);
		virtual void focusInEvent(QFocusEvent *ev);
		virtual void focusOutEvent(QFocusEvent *ev);
		
	private:
		QString clickMessage_;
		bool drawClickMsg_;
};

#endif

