// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#include <qptrlist.h>
#include <qframe.h>
#include <kaction.h>

#include "libldr.h"

class KLDrawColorPicker : public QFrame
{
	Q_OBJECT;
	
	public:
		KLDrawColorPicker(QWidget *parent = 0L, const char *name = 0L);
		~KLDrawColorPicker() {}
		
		void addColor(const ldraw::color_entity *c, int pos = -1);
		
	signals:
		void colorPicked(const ldraw::color_entity *);
		
	protected:
		void paintEvent(QPaintEvent *e);
		void mouseReleaseEvent(QMouseEvent *e);
		
	private:
		QPtrList<const ldraw::color_entity> colorList_;
};

class KLDrawColorPickerAction : public KAction
{
	Q_OBJECT;
	
	public:
		KLDrawColorPickerAction(KActionCollection *ac);
		virtual int plug(QWidget *w, int index = -1);
		
		KLDrawColorPicker* getWidget() { return widget_; }
		
	private:
		KLDrawColorPicker *widget_;
};
