// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#include <qlayout.h>
#include <qpushbutton.h>
#include <klocale.h>

#include "list.h"
#include "mainwindow.h"
#include "commondialog.h"

KLDrawCommonDialog::KLDrawCommonDialog() : QDialog(KLDrawMainWindow::self(), 0L, false)
{
	item_ = 0L;
	
	mainLayout_ = new QVBoxLayout(this, 11, 6);
}

void KLDrawCommonDialog::setCurrentItem(KLDrawListItem *i)
{
	item_ = i;
	
	refresh();
}

void KLDrawCommonDialog::actionOK()
{
	actionApply();
	close();
}

void KLDrawCommonDialog::addStandardButtons()
{
	mainLayout_->addItem(new QSpacerItem(20, 41, QSizePolicy::Minimum, QSizePolicy::Expanding));
	
	QFrame *line = new QFrame(this);
	line->setFrameShape(QFrame::HLine);
	line->setFrameShadow(QFrame::Sunken);
	mainLayout_->addWidget(line);
	
	buttonOk_ = new QPushButton(i18n("OK"), this);
	buttonOk_->setDefault(true);
	buttonApply_ = new QPushButton(i18n("Apply"), this);
	buttonCancel_ = new QPushButton(i18n("Cancel"), this);
	buttonCancel_->setAccel(QKeySequence("Esc"));
	
	QHBoxLayout *buttonLayout = new QHBoxLayout(0L, 0, 6);
	buttonLayout->addItem(new QSpacerItem(111, 21, QSizePolicy::Expanding, QSizePolicy::Minimum));
	buttonLayout->addWidget(buttonOk_);
	buttonLayout->addWidget(buttonApply_);
	buttonLayout->addWidget(buttonCancel_);
	mainLayout_->addLayout(buttonLayout);
	
	QObject::connect(buttonOk_, SIGNAL(clicked()), this, SLOT(actionOK()));
	QObject::connect(buttonApply_, SIGNAL(clicked()), this, SLOT(actionApply()));
	QObject::connect(buttonCancel_, SIGNAL(clicked()), this, SLOT(close()));
}
