// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#ifndef _DBMANAGER_H_
#define _DBMANAGER_H_

struct sqlite3;

class QString;
class QStringList;

class KLDrawDBManager
{
	public:
		KLDrawDBManager();
		~KLDrawDBManager();
		
		static KLDrawDBManager *instance_;
		static KLDrawDBManager* instance() { return instance_; }
		
		void rescanDB();
		
		QStringList query(const QString &statement);
		int insert(const QString &statement);
		
	private:
		bool hasTables();
		void createTables();
		
		sqlite3 *db_;
		bool isLoaded_;
};

#endif
