// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#ifndef _KLDRAW_H_
#define _KLDRAW_H_

#include <qmutex.h>
#include <qstring.h>

#include "libldr.h"

namespace KLDraw
{

extern QMutex globalDirsMutex;

QString escape(const QString &str);
QString unescape(const QString &str);
QString saveLocation(const QString &directory);
void checkQuadValidity(ldraw::model *m);
ldraw::matrix estimate(const ldraw::matrix &m);
float modulo(float dividend, float divisor);
std::string serializePOV(const ldraw::vector3d &v);
std::string serializePOV(const ldraw::matrix &m);

}

#endif
