// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#include "mainwindow.h"

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char description[] = I18N_NOOP("An interactive LDraw modeler for KDE");
static const char version[] = "0.1.0";

static KCmdLineOptions options[] =
{
//    { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
	KAboutData about(
		"kldraw", I18N_NOOP("KLDraw"), version, description,
		KAboutData::License_GPL, "(C) 2006 Park \"segfault\" J. K.", 0, 0, "nemesis@planetmono.org"
	);
	about.addAuthor( "Park \"segfault\" J. K.", "Developer", "nemesis@planetmono.org" );
	
	KCmdLineArgs::init(argc, argv, &about);
	KCmdLineArgs::addCmdLineOptions( options );
	
	KApplication app;
	KLDrawMainWindow *mainWin = 0;
	
	// no session.. just start up normally
	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
	
	/// @todo do something with the command line args here
	
	if (app.isRestored()) {
		RESTORE(KLDrawMainWindow);
	}
	else {
		mainWin = new KLDrawMainWindow();
		app.setMainWidget(mainWin);
		mainWin->show();
		args->clear();
	}
	
	return app.exec();
}

