// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#ifndef _MODELPROPERTIES_H_
#define _MODELPROPERTIES_H_

#include <qdialog.h>

class QLineEdit;
class QPushButton;
namespace ldraw {
	class model;
}

class KLDrawModelProperties : public QDialog
{
	Q_OBJECT;
	
	public:
		KLDrawModelProperties();
		//~KLDrawModelProperties();
		
		void setModel(ldraw::model *m);
		
	signals:
		void dataChanged();
		
	public slots:
		void actionOK();
		void actionApply();
		
	private slots:
		void setNameChanged();
		
	private:
		void refresh();
		
		bool nameChanged_;
		
		QLineEdit *nameEdit_;
		QLineEdit *descEdit_;
		QLineEdit *authorEdit_;
		
		QPushButton *buttonOk_;
		QPushButton *buttonApply_;
		QPushButton *buttonCancel_;
		
		ldraw::model *item_;
};

#endif
