// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#include <qcolor.h>

#include "libldr.h"

class KTempFile;

class KLDrawPOVRayRenderParameters
{
	public:
		KLDrawPOVRayRenderParameters();
		KLDrawPOVRayRenderParameters(const KLDrawPOVRayRenderParameters &p);
		~KLDrawPOVRayRenderParameters() {}
		
		/*
		 * Output format
		 */
		
		void setWidth(int p) { width_ = p; }
		void setHeight(int p) { height_ = p; }
		void setAntialiasing(bool p) { antialiasing_ = p; }
		
		int width() const { return width_; }
		int height() const { return height_; }
		bool antialiasing() const { return antialiasing_; }
		
		KTempFile* getIniFile() const;
		
		/*
		 * Rendering options
		 */
		
		void setBackgroundColor(QColor p) { backgroundColor_ = p; }
		void setDrawPlane(bool p) { drawPlane_ = p; }
		void setPlanePositionAuto(bool p) { planePositionAuto_ = p; }
		void setPlanePosition(float p) { planePosition_ = p; }
		void setPlaneColor(QColor p) { planeColor_ = p; }
		void setCameraLattitude(float p) { latitude_ = p; }
		void setCameraLongitude(float p) { longitude_ = p; }
		void setCameraRadius(float p) { radius_ = p; }
		void setCameraFOV(float p) { fov_ = p; }
		void setCameraOrthographic(bool p) { orthographic_ = p; }
		void setLights(int p) { lights_ = p; }
		void setLightsLongitude(float p) { lightsLongitude_ = p; }
		void setLightsLatitudeOffset(float p) { lightsLatitudeOffset_ = p; }
		void setLightsRadius(float p) { lightsRadius_ = p; }
		void setLightsIntensity(float p) { lightsIntensity_ = p; }
		void setLightsColor(QColor p) { lightsColor_ = p; }
		
		QColor backgroundColor() const { return backgroundColor_; }
		bool drawPlane() const { return drawPlane_; }
		bool planePositionAuto() const { return planePositionAuto_; }
		float planePosition() const { return planePosition_; }
		QColor planeColor() const { return planeColor_; }
		float cameraLatitude() const { return latitude_; }
		float cameraLongitude() const { return longitude_; }
		float cameraRadius() const { return radius_; }
		float cameraFOV() const { return fov_; }
		bool cameraOrthographic() const { return orthographic_; }
		int lights() const { return lights_; }
		float lightsLongitude() const { return lightsLongitude_; }
		float lightsLatitudeOffset() const { return lightsLatitudeOffset_; }
		float lightsRadius() const { return lightsRadius_; }
		float lightsIntensity() const { return lightsIntensity_; }
		QColor lightsColor() const { return lightsColor_; }
		
		KLDrawPOVRayRenderParameters operator= (const KLDrawPOVRayRenderParameters &p) const;
	
	private:
		int width_;
		int height_;
		bool antialiasing_;
		
		QColor backgroundColor_;
		bool drawPlane_;
		bool planePositionAuto_;
		float planePosition_;
		QColor planeColor_;
		float latitude_;
		float longitude_;
		float radius_;
		float fov_;
		bool orthographic_;
		int lights_;
		float lightsLongitude_;
		float lightsLatitudeOffset_;
		float lightsRadius_;
		float lightsIntensity_;
		QColor lightsColor_;
};
