// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#include <qlabel.h>
#include <qprogressbar.h>
#include <klocale.h>

#include "progresswidget.h"

KLDrawProgressWidget::KLDrawProgressWidget(QWidget *creator, const char *name)
	: QProgressDialog(creator, name, true)
{
	setLabelText(i18n("<p align=\"center\">Now building parts database and prerendering parts data.<br />Please be patient...</p>"));
	setAutoClose(true);
	
	resize(380, 120);
}

KLDrawProgressWidget::~KLDrawProgressWidget()
{
}

void KLDrawProgressWidget::updateProgress(int progress, int totalSteps)
{
	if (!(progress%12))
		setCaption(i18n("(%1/%2) Updating Database...").arg(progress).arg(totalSteps));
	setProgress(progress, totalSteps);
}
