// KLDraw - An interactive LDraw modeler for KDE
// Copyright (c)2006 Park "segfault" J. K. <nemesis@planetmono.org>

#ifndef _SUBMODELLIST_H_
#define _SUBMODELLIST_H_

#include <qptrlist.h>
#include <klistview.h>

#include "libldr.h"

class QString;
class QPainter;
class QPixmap;
class QColorGroup;
class QFontMetrics;
class KLDrawDocument;
class KLDrawSubmodelList;

class KLDrawSubmodelItem : public KListViewItem
{
	public:
		KLDrawSubmodelItem(ldraw::model *model, QPixmap *pm, QListView *parent);
		KLDrawSubmodelItem(ldraw::model *model, QPixmap *pm, QListView *parent, QListViewItem *after);
		~KLDrawSubmodelItem() {}
		
		int width(const QFontMetrics &fm, const QListView *lv, int c) const;
		
		ldraw::model* getModel() { return model_; }
		void setModel(ldraw::model *m, QPixmap *p = 0L);
		
	private:
		void setBase(bool enable);
		
		friend class KLDrawSubmodelList;
		
		ldraw::model *model_;
		bool isBase_;
};

class KLDrawSubmodelList : public KListView
{
	Q_OBJECT;
	
	public:
		KLDrawSubmodelList(QWidget *parent = 0L, const char *name = 0L);
		~KLDrawSubmodelList();
		
	public slots:
		void updateList();
		
	private:
		KLDrawDocument **activeDocument_;
		KLDrawSubmodelItem *baseModel_;
		QPtrList<KLDrawSubmodelItem> modelList_;
		
	protected:
		// Omit any keypress event
		void keyPressEvent(QKeyEvent *) {}
		void keyReleaseEvent(QKeyEvent *) {}
};

#endif
